import QtQuick 1.0
import Qt3D 1.0

ShaderProgram {
    property real near: mainCamera.nearPlane
    property real far: mainCamera.farPlane

    property color sphereColor
    vertexShader: "
    attribute highp vec4 qt_Vertex;
    attribute highp vec3 qt_Normal;
    uniform highp mat4 qt_ModelViewProjectionMatrix;
    uniform highp mat4 qt_ModelViewMatrix;
    uniform highp mat3 qt_NormalMatrix;
    uniform mediump vec3 sunPos;

    varying highp vec3 normal;
    varying highp vec3 toLight;

    void main(void)
    {
        gl_Position = qt_ModelViewProjectionMatrix * qt_Vertex;
        normal = qt_NormalMatrix * qt_Normal;
        highp vec4 vertexEyeSpace = qt_ModelViewMatrix * qt_Vertex;
        highp vec4 sunPosEyeSpace=vec4(10,10,0,1);
        toLight = (sunPosEyeSpace-vertexEyeSpace).xyz;
    }
    "
    fragmentShader: "
    uniform mediump float near;
    uniform mediump float far;
    uniform lowp vec4 sphereColor;
    varying highp vec3 normal;
    varying highp vec3 toLight;

    void main(void)
    {
        mediump float dp=dot(normalize(normal),normalize(toLight));
        dp=clamp((dp+1.0)*0.5,0.0,1.0);
        mediump float depth=clamp(1.5*(1.0-pow(gl_FragCoord.z,2.0)),0.0,1.0);
        gl_FragColor=vec4(depth*dp*sphereColor.rgb, 1.0);
    }
    "
}
