import QtQuick 1.0

Item {
    width: controlPanel.stdWidth
    height: controlPanel.stdHeight
    property string text: ""
    property string iconSource: ""
    property bool pressed: false
    property bool ok: true
    property color lightColor: controlPanel.stdColor
    property color darkColor: "black"
    signal clicked
    Item {
        x: 1; width: parent.width-2
        y: 1; height: parent.height-2
        Rectangle {
            anchors.fill: parent
            radius: 3
            border.width: parent.parent.ok ? 3 : 5
            border.color: parent.parent.text=="" && !parent.parent.ok ? "red" :
                parent.parent.pressed ? lightColor : darkColor
            color: "transparent"
            Rectangle {
                opacity: 0.5
                anchors.centerIn: parent
                width: parent.width-2
                height: parent.height-2
                radius: parent.radius
                color: darkColor
            }
        }
        Image {
            visible: parent.parent.iconSource!==""
            anchors.centerIn: parent
            width: parent.width-8
            height: parent.height-8
            source: parent.parent.iconSource
            Rectangle {
                anchors.fill: parent
                color: "black"
                opacity: 0.5
            }
        }
        Text {
            visible: parent.parent.text!==""
            anchors.horizontalCenter: parent.horizontalCenter
            y: parent.height*0.5
            height: 0
            horizontalAlignment: Text.AlignHCenter
            verticalAlignment: Text.AlignVCenter
            font.family: "Nokia Pure"
            font.bold: true
            font.pixelSize: parent.height/2
            color: parent.parent.ok ? lightColor : "red"
            text: parent.parent.text
        }
        Rectangle {
            anchors.centerIn: parent
            color: "red"
            width: parent.width
            height: width*0.1
            rotation: -50
            visible: !parent.parent.ok
        }

        MouseArea {
            anchors.fill: parent
            onClicked: {
                controlPanel.tickle()
                parent.parent.clicked()
            }
        }
    }
}
