import QtQuick 1.0

Item {
    id: controlPanel
    anchors.fill: parent

    // externally visible properties
    property bool trackEarth: false
    property real maxSize: 3
    property bool clip111: false
    function includes(x,y,z) {
        var absx=Math.abs(x)
        var absy=Math.abs(y)
        var absz=Math.abs(z)
        var clip100=absx<=maxSize && absy<=maxSize && absz<=maxSize
        if (!clip100) return false
        if (clip111 && absx+absy+absz>maxSize*2) return false
        return true
    }

    // visibility management
    property bool show: false
    function tickle() {
        controlPanel.show=true
        showTimer.restart()
    }
    Timer {
        id: showTimer
        interval: 10000
        onTriggered: {
            controlPanel.show=false
        }
    }
    MouseArea {
        x: 0; width: parent.width
        y: 0; height: parent.height/8
        onClicked: { controlPanel.tickle() }
    }

    // palette and sizing
    property color stdColor: controlPanel.show ? "#22cccc" : "#22cccc"
    Behavior on stdColor { ColorAnimation { duration: 500 } }
    property real stdWidth: 80
    property real stdHeight: 80

    // controls
    Row {
        anchors.top: parent.top
        anchors.right: parent.right
        opacity: controlPanel.show ? 1 : 0
        Behavior on opacity { NumberAnimation {duration: 500 } }

        Button {
            text: "111"
            pressed: controlPanel.clip111
            onClicked: {
                controlPanel.clip111=!controlPanel.clip111
            }
        }

        Button {
            text: "X"
            onClicked: { Qt.quit() }
        }
    }
}
